]> git.phdru.name Git - dotfiles.git/blob - .shellrc
5b1e1d3db39e784807906f1446974f0824843281
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 # Remove trainling \$s
62 OPS1="`echo $OPS1 | sed 's/[ \\$]\+$//'`"
63 # Add a trainling space
64 OPS1="$OPS1 "
65 # Re-add trainling \$
66 for ((i=0; i<$SHLVL; i++)); do OPS1="$OPS1\\$"; done
67
68 PS1="$OPS1 "
69
70
71 if test -n "$BASH_VERSION"; then
72    [ "`type -t ls`" = alias ] && unalias ls
73    [ "`type -t ll`" = alias ] && unalias ll
74    [ "`type -t mc`" = alias ] && unalias mc
75
76    back() { cd - "$@"; }
77    functions() { typeset -f "$@"; }
78    j() { jobs; }
79
80    has_completion() { return 0; }
81    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
82       if [ "$SHELL" = /bin/bash ]; then
83          if [ -d /usr/share/bash-completion -a -f /usr/share/bash-completion/bash_completion ]; then
84             . /usr/share/bash-completion/bash_completion
85             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
86          elif [ -f /etc/bash_completion ]; then
87             . /etc/bash_completion
88             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
89          elif [ -d /etc/bash_completion.d ]; then
90             for _compf in /etc/bash_completion.d/*; do
91                . $_compf
92             done
93             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
94          fi
95       elif [ "$SHELL" = /usr/local/bin/bash ]; then
96          if [ -d /usr/local/etc/bash_completion.d ]; then
97             for _compf in /usr/local/etc/bash_completion.d/*; do
98                . $_compf
99             done
100             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
101          fi
102       else
103          echo "Unknown OS type, cannot source bash_completion" >&2
104       fi
105    fi
106
107    for cmd in builtin cgmem_nice command dbus-launch exec \
108       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
109       time whence whereis which xargs; do
110          ! has_completion $cmd && complete -o default -A command $cmd
111    done
112
113    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
114       telnet t tt \
115       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
116       whois wd wget wget-download wget-m wget-wrapper ww; do
117          ! has_completion $cmd && complete -A hostname $cmd
118    done
119
120    for cmd in distribute ftp lftp r rsync \
121       s scp ssh smbclient tcpdump tshark wireshark; do
122          ! has_completion $cmd && complete -o default -A hostname $cmd
123    done
124
125    if [ -d "$HOME"/.bash_completion.d ]; then
126       for _compf in "$HOME"/.bash_completion.d/*; do
127          . $_compf
128       done
129    fi
130
131    delegate_completion() {
132       local prog programs
133       prog=$1
134       if has_completion $prog; then
135          shift
136          programs="$@"
137          eval "_${prog}_completion_loader() {
138             _completion_loader $prog
139             complete -o nospace -F _$prog $programs
140             unset _${prog}_completion_loader
141             return 124
142          }"
143          complete -F _${prog}_completion_loader $programs
144       fi
145    }
146
147    delegate_completion make m
148    delegate_completion ping p
149    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
150    delegate_completion ssh s
151    delegate_completion wget wget-m wget-wrapper ww
152
153    unset has_completion delegate_completion
154
155    complete -A job bg fg j jobs wait
156    complete -A variable -A function unset
157
158    if [ -d "$HOME/lib/config" ]; then
159       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
160    fi
161    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
162
163    #if type -p pip >/dev/null 2>&1; then
164    #   eval "`pip completion --bash`"
165    #   rm -rf /tmp/pip_build_"$USER"
166    #fi
167
168    #if which pyenv >/dev/null 2>&1; then
169    #   eval "`pyenv init -`"
170    #   eval "`pyenv virtualenv-init -`"
171    #fi
172
173    . virtualenvwrapper_lazy.sh 2>/dev/null
174
175    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
176       . "$VIRTUAL_ENV/bin/activate"
177    fi
178
179    # Clean up python virtual environment on exit
180    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
181
182    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
183
184 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
185    back() { cd - "$@"; }
186    j() { jobs; }
187 fi
188
189
190 # clear screen and history, logout
191 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
192
193
194 if test -x /usr/bin/git >/dev/null 2>&1; then
195    # chdir to a directory
196    cdgitpath() {
197       if [ $# -ne 1 ]; then
198          echo "Usage: cdgitpath path_key" >&2
199          return 1
200       fi
201
202       path_key="$1"
203       if [ -z "$path_key" ]; then
204          echo "Usage: cdgitpath path_key" >&2
205          return 1
206       fi
207
208       path_url="`git config --get --path $path_key`"
209       if echo "$path_url" | grep -q '^file:/'; then
210          path_url="`echo \"$path_url\" | sed 's@^file:/\+@/@'`"
211       fi
212       cd "$path_url"
213    }
214
215    # chdir to a remote's directory (if the remote is on the local FS)
216    cdremote() {
217       if [ $# -gt 1 ]; then
218          echo "Usage: cdremote [remote_name]" >&2
219          return 1
220       fi
221
222       if [ -z "$1" ]; then
223          branch="`git rev-parse --abbrev-ref HEAD`"
224          remote="`git config --get branch.$branch.remote`"
225       else
226          remote="$1"
227       fi
228
229       if [ -n "$remote" ] && git config --get remote.$remote.url |
230             grep -q '^\(file:/\|/\|\.\./\)'; then # (file:/ or / or ../ at the beginning)
231          cdgitpath remote.$remote.url
232       else
233
234          if [ -n "$1" ]; then
235             echo "Cannot find directory for remote $1" >&2
236             echo "Usage: cdremote [remote_name]" >&2
237             return 1
238          fi
239
240          if test -n "$BASH_VERSION"; then
241             _list_remotes '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
242             if [ ${#GIT_REMOTES[*]} -eq 1 ]; then
243                remote=${GIT_REMOTES[0]}
244                unset GIT_REMOTES
245                cdgitpath remote.$remote.url
246             else
247                unset GIT_REMOTES
248                echo "Cannot find directory for any remote" >&2
249                echo "Usage: cdremote [remote_name]" >&2
250                return 1
251             fi
252          else
253             echo "Cannot find directory for remote $1" >&2
254             echo "Usage: cdremote [remote_name]" >&2
255             return 1
256          fi
257       fi
258    }
259
260    if test -n "$BASH_VERSION"; then
261       # completion for aliases in global .gitconfig
262
263       # fixup rbi rbia rbiap rbip - do refs name completion
264       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
265       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
266       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
267       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
268       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
269       #
270       # push-to-all-remotes - do branch name completion
271       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
272
273       _cdgitpath_complete() {
274          local cur="${COMP_WORDS[COMP_CWORD]}"
275          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
276       }
277
278       _git_open() {
279          _cdgitpath_complete
280       }
281
282       complete -F _cdgitpath_complete cdgitpath git-open
283
284       # list remotes with URLs matching a regexp
285       _list_remotes() {
286          if [ $# -ne 1 ]; then
287             echo "Usage: _list_remotes remote_regexp" >&2
288             return 1
289          fi
290          declare -ag GIT_REMOTES=()
291          local remote
292          for remote in `git remote`; do
293             if git config --get remote.$remote.url | grep -q "$1"; then
294                GIT_REMOTES+=($remote)
295             fi
296          done
297       }
298
299       # completion for cdremote and git-open-remote - list remotes with a pattern
300       _list_remotes_completion() {
301          local cur="${COMP_WORDS[COMP_CWORD]}"
302          _list_remotes "$1"
303          COMPREPLY=(`compgen -W "${GIT_REMOTES[*]}" -- "$cur"`)
304          unset GIT_REMOTES
305       }
306
307       # completion for cdremote - list remotes with directories as URLs
308       _cdremote_complete() {
309          _list_remotes_completion '^\(file:/\|/\|\.\./\)' # (file:/ or / or ../ at the beginning)
310          if [ ${#COMPREPLY[*]} -eq 0 ]; then
311             _list_remotes_completion .
312          fi
313       }
314
315       complete -F _cdremote_complete cdremote
316
317       # completion for git-open-remote - list remotes with http(s) URLs
318       _git_open_remote() {
319          _list_remotes_completion '^http\(s\)\?://'
320          if [ ${#COMPREPLY[*]} -eq 0 ]; then
321             _list_remotes_completion .
322          fi
323       }
324
325       complete -F _git_open_remote git-open-remote
326    fi
327 fi
328
329
330 include() {
331    cfg="$1"
332    if [ -f "./$cfg" -a -r "./$cfg" ]; then
333       echo "Reading config file \`$cfg'" 1>&2
334       . "./$cfg"
335    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
336       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
337       . "$HOME/lib/config/$cfg"
338    else
339       echo "Cannot find config file \`$cfg'" 1>&2
340    fi
341 }
342
343
344 mc() {
345    if test -n "$BASH_VERSION"; then
346       MC_SAVE_OPS1="$OPS1"
347       OPS1="\u@\h "
348    fi
349
350    if [ -n "$SLOWTERM" ]; then
351       MC_SLOW="--slow"
352    fi
353
354    case "$TERM" in
355       screen*) # screen, screen.rxvt
356          MC_XTERM="-x"
357       ;;
358    esac
359
360    #TMPDIR="$HOME"/tmp
361    #export TMPDIR
362
363    MC_FOUND=NO
364
365    for wrapper in \
366          /usr/local/share/mc/bin/mc-wrapper.sh \
367          /usr/local/libexec/mc/mc-wrapper.sh \
368          /usr/share/mc/bin/mc-wrapper.sh; do
369       if [ -r $wrapper ]; then
370          . $wrapper $MC_SLOW $MC_XTERM "$@"
371          rc=$?
372          MC_FOUND=YES
373          break
374       fi
375    done
376
377    if [ $MC_FOUND = NO ]; then
378       for mc in /usr/local/bin/mc /usr/bin/mc; do
379          if [ -x $mc ]; then
380             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
381             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
382                MC_TMP_DIR="${TMPDIR-/tmp}"
383             fi
384             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
385             mc_type="`mc_type.py $mc`"
386             if [ "$mc_type" = old ]; then
387                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
388             elif [ "$mc_type" = new ]; then
389                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
390             else
391                continue
392             fi
393             rc=$?
394             MC_FOUND=YES
395             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
396             break
397          fi
398       done
399    fi
400
401    if [ $MC_FOUND = NO ]; then
402       echo "Cannot find mc-wrapper.sh or mc" >&2
403       rc=1
404    fi
405
406    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
407    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SLOW MC_TMP_DIR MC_XTERM
408
409    return $rc
410 }
411
412
413 mkcd() {
414    if [ $# -ne 1 ]; then
415       echo "Usage: mkcd directory_name" >&2
416    elif [ -d "$1" ]; then
417       cd "$1"
418    elif [ -e "$1" ]; then
419       echo "Error: $1 is a file" >&2
420    else
421       mkdir -p "$1" && cd "$1"
422    fi
423 }
424
425
426 if which tmux >/dev/null 2>&1; then
427    tmux() {
428       case "$TERM" in
429          rxvt)
430             TERM=rxvt-unicode command tmux "$@"
431          ;;
432
433          *)
434             command tmux "$@"
435          ;;
436       esac
437    }
438 fi
439
440
441 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
442    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
443 fi
444
445 x() { exit; }